Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneEntity.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneEntity.h	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneEntity.h	(revision 3260)
@@ -19,5 +19,5 @@
 
 /** Class representing a scene entity.
-    A scene entity basically consists of geometry, transformation, and a material
+    A scene entity basically consists of one or more shapes and a transformation.
 */
 class SceneEntity
@@ -109,5 +109,5 @@
 	//-- static functions
 
-	/** If false, the highest (most detailed) LOD level is used for all entities.
+	/** If false, the highest (=most detailed) LOD level is used for all entities.
 	*/
 	static void SetUseLODs(bool useLODs);
@@ -119,10 +119,10 @@
 	*/
 	static void SetCurrentVisibleId(int id);
-
+	/** Returns the id that indicates a visible object.
+	*/
 	static int GetCurrentVisibleId();
 
 
 protected:
-
 
 	/** Internally updates current lod level.
@@ -159,5 +159,4 @@
 	/// if LODs are used for rendering: otherwise we always take the highest lod
 	static bool sUseLODs;
-
 };
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Geometry.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Geometry.h	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Geometry.h	(revision 3260)
@@ -62,4 +62,5 @@
 
 protected:
+
 	/** Calculates the bounding box from the vertices.
 	*/
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhExporter.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhExporter.h	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhExporter.h	(revision 3260)
@@ -1,4 +1,4 @@
-#ifndef __PVS_H
-#define __PVS_H
+#ifndef __BVHEXPORTER_H
+#define __BVHEXPORTER_H
 
 #include "common.h"
@@ -16,5 +16,5 @@
 public:
 
-	bool ExportToFile(const std::string &filename, Bvh *bvh);
+	bool Export(const std::string &filename, Bvh *bvh);
 
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/ResourceManager.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/ResourceManager.cpp	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/ResourceManager.cpp	(revision 3260)
@@ -383,5 +383,6 @@
 	}
 
-	const bool delGeometry = true;
+	//const bool delGeometry = true;
+	const bool delGeometry = false;
 	return new Geometry(vertices, normals, texcoords, vertexCount, delGeometry, NULL);//tangents);
 }
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3260)
@@ -61,4 +61,6 @@
 #include "ViewCellsTree.h"
 #include "PvsCollectionRenderer.h"
+#include "ObjExporter.h"
+#include "BvhExporter.h"
 
 
@@ -644,4 +646,9 @@
 
 
+	ObjExporter().Export(model_path + "mycity.obj", bvh);
+	BvhExporter().Export(model_path + "mycity.bvh", bvh);
+
+
+
 	//////////////////
 	//-- setup the skydome model
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhExporter.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhExporter.cpp	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhExporter.cpp	(revision 3260)
@@ -76,5 +76,5 @@
 
 
-bool BvhExporter::ExportToFile(const string &filename, Bvh *bvh)
+bool BvhExporter::Export(const string &filename, Bvh *bvh)
 {
 	 cout << "Info: Exporting to file '" << filename.c_str() << "'" << endl;
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/VboFormatConverter.vcproj
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/VboFormatConverter.vcproj	(revision 3235)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/VboFormatConverter.vcproj	(revision 3260)
@@ -19,5 +19,5 @@
 			Name="Debug|Win32"
 			OutputDirectory="$(SolutionDir)$\VboFormatConverter\(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)\VboFormatConverter"
+			IntermediateDirectory="$(ConfigurationName)\$(ProjectName)"
 			ConfigurationType="1"
 			CharacterSet="1"
@@ -98,5 +98,5 @@
 		<Configuration
 			Name="Release|Win32"
-			OutputDirectory="$(SolutionDir)$\$(ProjectName)\(ConfigurationName)"
+			OutputDirectory="$(SolutionDir)\$(ProjectName)\$(ConfigurationName)"
 			IntermediateDirectory="$(ConfigurationName)\$(ProjectName)"
 			ConfigurationType="1"
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj	(revision 3260)
@@ -19,5 +19,5 @@
 			Name="Debug|Win32"
 			OutputDirectory="$(SolutionDir)/lib/$(ConfigurationName)"
-			IntermediateDirectory="obj/$(ConfigurationName)"
+			IntermediateDirectory="$(SolutionDir)/obj/$(ConfigurationName)"
 			ConfigurationType="4"
 			CharacterSet="1"
@@ -83,5 +83,5 @@
 			Name="Release|Win32"
 			OutputDirectory="$(SolutionDir)/lib/$(ConfigurationName)"
-			IntermediateDirectory="obj/$(ConfigurationName)"
+			IntermediateDirectory="$(SolutionDir)/obj/$(ConfigurationName)"
 			ConfigurationType="4"
 			CharacterSet="1"
@@ -515,4 +515,8 @@
 				</File>
 				<File
+					RelativePath=".\src\ObjExporter.h"
+					>
+				</File>
+				<File
 					RelativePath=".\src\OcclusionQuery.h"
 					>
@@ -645,4 +649,8 @@
 				</File>
 				<File
+					RelativePath=".\src\ObjExporter.cpp"
+					>
+				</File>
+				<File
 					RelativePath=".\src\OcclusionQuery.cpp"
 					>
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter.cpp	(revision 3247)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter.cpp	(revision 3260)
@@ -170,5 +170,5 @@
 	geom->mMaterial = mat;
 
-	cout << "new geometry #vts=" << numElements << endl;
+	cout << "creating new geometry with " << numElements << " vertices" << endl;
 
 	for (int i = 0; i < numElements; ++ i)
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env	(revision 3259)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env	(revision 3260)
@@ -115,9 +115,9 @@
 ## powerplant options
 
-filename=PowerPlantM
-keyForwardMotion=500.0f
-mouseMotion=3.0f
-visibilitySolution=power-plant-2c-xx-1000b-pgv2
-camPosition=-1320.57 -6306.34 3603
-camDirection=0.292156 0.9556 0.0383878
-viewCellsScaleFactor=0.05f
+#filename=PowerPlantM
+#keyForwardMotion=500.0f
+#mouseMotion=3.0f
+#visibilitySolution=power-plant-2c-xx-1000b-pgv2
+#camPosition=-1320.57 -6306.34 3603
+#camDirection=0.292156 0.9556 0.0383878
+#viewCellsScaleFactor=0.05f